/*** mouse.pro ***/
% by Penkov Srgey, Moscow, old version
constants

n_help=2
up_window=3
s_right_form=	"Right"
s_left_form=	"Left"
s_down_form=	"Down"
s_up_form=	"Up"
s_outside_form=	"Out"
s_inside_form=	"Center"

fon=		$0000

right_form=	$201A
left_form=	$201b
down_form=	$3019
up_form=	$3018
outside_form=	$4704

left_up_form=	$601a
right_up_form=	$601b
left_down_form=	$6019
right_down_form=$6018
enter_form=	$0001
inside_form=	$1700		% 1xxx	-blue 1704
				% 2xxx	-green
				% 3xxx	-light blue
				% 4xxx	-red
				% 5xxx	-magenta
				% 6xxx	-broun
				% 7xxx	-white
				% 8xxx	-black
				% 9xxx	-blue blinking
				% axxx	-green blinking

predicates
%		init_mouse_driver
%		set_mouse(INTEGER,INTEGER)
		set_mouse_limit
		set_form(INTEGER,INTEGER,INTEGER,INTEGER,INTEGER,INTEGER,INTEGER)
%		read_mouse(INTEGER,INTEGER,INTEGER)
		mouse(KEY,INTEGER,INTEGER,INTEGER,INTEGER,INTEGER)
		get_mouse_key(integer,INTEGER,INTEGER,INTEGER,
			INTEGER,INTEGER,KEY)
%		complex_key(INTEGER,KEY)
		keyboard(KEY,KEY)
%		del_mouse_cursor
%		dsp_mouse_cursor
%		assert_form(INTEGER)
		inside(INTEGER,INTEGER,INTEGER)
		show_form(INTEGER)
		wait_release(INTEGER,INTEGER)
		get_color(INTEGER,INTEGER,INTEGER,INTEGER,INTEGER)
%		set_screen_cursor(ROW,COL)
		proces(KEY)
%		delay(INTEGER)
		place_cursor(INTEGER,INTEGER,INTEGER,INTEGER,INTEGER)
		
CLAUSES
complex_key(FOLLOW,Key):-
		makewindow(_,_,_,_,Ymin,Xmin,Nr,Nc),
		dsp_mouse_cursor,
		repeat,
		mouse(Key1,Ymin,Xmin,Nr,Nc,FOLLOW),
		keyboard(Key1,Key),!,
		del_mouse_cursor.

keyboard(correct,KEY):-!,
		keypressed,
		readkey(KEY),
		proces(KEY).
keyboard(Key,Key).

mouse(correct,Ymin,Xmin,Nr,Nc,0):-
		read_mouse(Stat,Ymouse,Xmouse),
		Ymax=Ymin+Nr-1,
		Xmax=Xmin+Nc-1,
		set_form(Xmouse,Ymouse,Xmin,Ymin,Xmax,Ymax,MOUSE_FORM),
		show_form(MOUSE_FORM),Stat=0,!.
mouse(Key,Ymin,Xmin,Nr,Nc,FOLLOW):-	!,
		cursor(Yc,Xc),
		Ymax=Ymin+Nr-1,
		Xmax=Xmin+Nc-1,
		read_mouse(Stat,Ymouse,Xmouse),
		set_form(Xmouse,Ymouse,Xmin,Ymin,Xmax,Ymax,MOUSE_FORM),
		show_form(MOUSE_FORM),
		Xmouse1=Xmouse-Xmin-1,Ymouse1=Ymouse-Ymin-1,
		get_mouse_key(MOUSE_FORM,Stat,Xc,Yc,Xmouse1,Ymouse1,Key),
		wait_release(Stat,MOUSE_FORM),
		place_cursor(MOUSE_FORM,Stat,Ymouse1,Xmouse1,FOLLOW).

place_cursor(inside_form,0,_,_,0):-!.
place_cursor(inside_form,Stat,ROW,COL,0):-Stat>0,!,
		cursorform(3,8),cursor(ROW,COL).
place_cursor(_,_,_,_,_).
set_mouse(Stat,Buttons):-
		bios($33,reg(0,0,0,0,0,0,0,0),reg(Stat,Buttons,_,_,_,_,_,_)).

wait_release(0,_):-!.
wait_release(BUTTON,MOUSE_FORM):-
		makewindow(_,Watr,Fatr,_,_,_,_,_),
		get_color(enter_form,Fon,NewCursor,Watr,Fatr),
		del_mouse_cursor,
		bios($33,reg(10,0,Fon,NewCursor,0,0,0,0),_),!,
		dsp_mouse_cursor,
		repeat,	% wait release button
		bios($33,reg(6,BUTTON,0,0,0,0,0,0),reg(REL,_,_,_,_,_,_,_)),
		bitand(BUTTON,REL,RES),
		RES=0,!,
		del_mouse_cursor,
		bios($33,reg(10,0,fon,MOUSE_FORM,0,0,0,0),_),
		dsp_mouse_cursor.

show_form(MOUSE_FORM):-
		not(mouse_form(MOUSE_FORM)),!,
		del_mouse_cursor,
		bios($33,reg(10,0,fon,MOUSE_FORM,0,0,0,0),_),
		assert_form(MOUSE_FORM),
		dsp_mouse_cursor.
show_form(_).

get_color(Cursor_form,Fon,NewCursor,Watr,Fatr):-
		bitand(Watr,$0007,F0),bitleft(F0,12,Fon),
		bitand(Fatr,$0070,C0),bitleft(C0,4,C1),bitor(C1,Fon,C_col),
		bitor(C_col,Cursor_form,NewCursor).

get_mouse_key(outside_form,2,_,_,_,_,esc):-!.
get_mouse_key(inside_form,1,_,_,_,_,click):-!.
get_mouse_key(inside_form,2,_,_,_,_,fkey(10)):-!.
get_mouse_key(left_form,1,_,_,_,_,ctrlleft):-!.
get_mouse_key(right_form,1,_,_,_,_,ctrlright):-!.
get_mouse_key(up_form,1,_,_,_,_,pgup):-!.
get_mouse_key(down_form,1,_,_,_,_,pgdn):-!.
get_mouse_key(left_up_form,1,_,_,_,_,fkey(1)):-!.
get_mouse_key(left_down_form,1,_,_,_,_,fkey(2)):-!.
get_mouse_key(right_up_form,1,_,_,_,_,fkey(3)):-!.
get_mouse_key(right_down_form,1,_,_,_,_,fkey(4)):-!.
get_mouse_key(outside_form,1,_,_,_,_,esc):-!.
get_mouse_key(inside_form,0,Xc,Yc,Xmouse,Ymouse,Key):-
		Ymouse>Yc,Xmouse=Xc,!,cursor(Ymouse,Xmouse),Key=down;
		Ymouse<Yc,Xmouse=Xc,!,cursor(Ymouse,Xmouse),Key=up;
		Ymouse=Yc,Xmouse>Xc,!,cursor(Ymouse,Xmouse),Key=right;
		Ymouse=Yc,Xmouse<Xc,!,cursor(Ymouse,Xmouse),Key=left;
		cursor(Ymouse,Xmouse),Key=correct,!.
get_mouse_key(_,0,_,_,_,_,correct):-!.

inside(X,MIN,MAX):-X<MAX,X>MIN.

set_form(Xmouse,Ymouse,Xmin,Ymin,Xmax,Ymax,inside_form):-
		Xmouse<Xmax,Ymouse<Ymax,Xmouse>Xmin,Ymouse>Ymin,!.
set_form(Xmin,Y,Xmin,MIN,_,MAX,	left_form):-	inside(Y,MIN,MAX),!.
set_form(X,Ymin,MIN,Ymin,MAX,_,	up_form):-	inside(X,MIN,MAX),!.
set_form(Xmax,Y,_,MIN,Xmax,MAX,	right_form):-	inside(Y,MIN,MAX),!.
set_form(X,Ymax,MIN,_,MAX,Ymax,	down_form):-	inside(X,MIN,MAX),!.
set_form(Xmin,Ymin,Xmin,Ymin,_,_,left_up_form):-!.
set_form(Xmin,Ymax,Xmin,_,_,Ymax,left_down_form):-!.
set_form(Xmax,Ymin,_,Ymin,Xmax,_,right_up_form):-!.
set_form(Xmax,Ymax,_,_,Xmax,Ymax,right_down_form):-!.
set_form(_,_,_,_,_,_,		outside_form).

proces(up):-	cursor(R,C),R1=R-1,max(R1,0,NEW),set_screen_cursor(NEW,C),!.
proces(down):-	cursor(R,C),R1=R+1,
		makewindow(_,_,_,_,_,_,Nr,_),N1=Nr-3,
		min(R1,N1,NEW),set_screen_cursor(NEW,C),!.
proces(left):-	cursor(R,C),C1=C-1,max(C1,0,NEW),set_screen_cursor(R,NEW),!.
proces(right):-	cursor(R,C),C1=C+1,!,
		makewindow(_,_,_,_,_,_,_,Nc),N1=Nc-3,
		min(C1,N1,NEW),set_screen_cursor(R,NEW).
proces(home):-	cursor(R,_),cursor(R,0),!.
proces(end):-	cursor(R,_),
		makewindow(_,_,_,_,_,_,_,Nc),N1=Nc-3,
		cursor(R,N1),!.
proces(pgdn):-	cursor(_,COL),
		makewindow(_,_,_,_,_,_,Nr,_),N1=Nr-3,
		cursor(N1,COL),!.
proces(pgup):-	cursor(_,COL),
		cursor(0,COL),!.

proces(_).

set_mouse_limit:-makewindow(_,_,_,_,R,C,Nr,Nc),
		Xmin=C*8+1,Xmax=Xmin+Nc*8-2,Ymin=R*8+1,Ymax=Ymin+Nr*8-2,
		bios($33,reg(7,0,Xmin,Xmax,0,0,0,0),reg(_,_,_,_,_,_,_,_)),
		bios($33,reg(8,0,Ymin,Ymax,0,0,0,0),reg(_,_,_,_,_,_,_,_)).
