/****************************** DRAW RIGHT ****************************/

PREDICATES
  draw_right(TREE,ROW,ROW,COL,COL,COL,COL,ROW)
  draw_rightlist(TREELIST,ROWLIST,ROWLIST,ROW,ROW,COL,COL,COL,COL)
  connect_nodesright(ROW,COL,INTEGER,COL,ROWLIST)
  con_nodesright(ROW,COL,ROW,ROW,COL,ROWLIST)
  cornerright(ROW,ROW,ROW,ROW,CHAR)
  check_lastright(ROW,COL,ROWLIST)

CLAUSES
 
  draw_right(_,_,_,_,_,_,_,_):-
  			keypressed,!,
  			complex_key(follow,KEY),
  			treekeyact(KEY),fail.
  draw_right(tree(NAME,_,SELECT,[]),CURROW,NEWCURROW,LASTNAMECOL,CURCOL,CURCOL,_,RESROW):-!,
	incrow(CURROW,NEWCURROW,LASTNAMECOL,CURCOL),
	RESROW=NEWCURROW,
	writetext(RESROW,CURCOL,112,NAME,SELECT).
  draw_right(tree(NAME,_,SELECT,TREELIST),CURROW,NEWCURROW,LASTNAMECOL,NEXTNAMECOL,CURCOL,COLSTEP,RESROW):-
	str_len(NAME,NAMELEN),
	CURCOL1=1+NAMELEN+CURCOL+COLSTEP,
	draw_rightlist(TREELIST,[],NODEROWLIST,CURROW,NEWCURROW,LASTNAMECOL,NEXTNAMECOL,CURCOL1,COLSTEP),
	nodelistlen(NODEROWLIST,LEN),
	listsum(NODEROWLIST,SUM),
	RESROW=SUM div LEN,
	COLAFTERNAME=1+CURCOL+NAMELEN,
	connect_nodesright(RESROW,COLAFTERNAME,LEN,CURCOL1,NODEROWLIST),
	writetext(RESROW,CURCOL,112,NAME,SELECT),
	COLAFTERNAME1=CURCOL+NAMELEN,
	scr_ch(RESROW,COLAFTERNAME1,''),
	check_lastright(RESROW,COLAFTERNAME,NODEROWLIST).

  draw_rightlist([],NodeRowList,NodeRowList,CurRow,CurRow,NEXTNAMECOL,NEXTNAMECOL,_,_).
  draw_rightlist([H|T],NodeRowList,ResNodeRowList,CurRow,CurRow2,LNCOL1,LNCOL3,CurCol,Colstep):-
	draw_right(H,CurRow,Currow1,LNCOL1,LNCOL2,Curcol,Colstep,Noderow),
	draw_rightlist(T,[Noderow|NodeRowList],ResNodeRowList,CurRow1,CurRow2,LNCOL2,LNCOL3,CurCol,Colstep).

  check_lastright(ROW,_,[ROW|_]):-!.
  check_lastright(ROW,COL,[_|LIST]):-!,check_lastright(ROW,COL,LIST).
  check_lastright(ROW,COL,_):-scr_ch(ROW,COL,'').

  connect_nodesright(ROW,COL,1,COL1,_) :-!,
        treeline_hor(COL,COL1,ROW).
  connect_nodesright(ROW,COL,_,COL1,[RMAX|L]):-
        lastinlist(RMIN,[RMAX|L]),
        con_nodesright(ROW,COL,RMIN,RMAX,COL1,[RMAX|L]).

  con_nodesright(_,_,_,_,_,[]).
  con_nodesright(_,COL,_,_,_,[R1,R2|_]):-
	R22=R2+1,
	treeline_ver(R22,R1,COL), fail.
  con_nodesright(ROW,COL,RMIN,RMAX,COL1,[ROW1|T]):-
	CC=COL+1,
	treeline_hor(CC,COL1,ROW1),
	cornerright(ROW,RMIN,RMAX,ROW1,CORNCHAR),
	scr_ch(ROW1,COL,CORNCHAR),
	con_nodesright(ROW,COL,RMIN,RMAX,COL1,T).

  cornerright(RMIN,RMIN,_,RMIN,'') :- !.
  cornerright(RMAX,_,RMAX,RMAX,'') :- !.
  cornerright(_,RMIN,_,RMIN,'') :- !.
  cornerright(_,_,RMAX,RMAX,'') :- !.
  cornerright(RMIDT,_,_,RMIDT,'') :- !.
  cornerright(_,_,_,_,'').

/************************** END DRAW RIGHT ****************************/
