
PREDICATES
/*
nondeterm 	repeat
  delay(INTEGER)
  nondeterm   for(INTEGER,INTEGER,INTEGER)
  get_screen_name(STRING)
  attention(STRING)
  maxvalue(INTEGERLIST,INTEGER)
  maxlen(STRINGLIST,COL,COL)		/* The length of the longest string */
  listlen(STRINGLIST,ROW)		/* The length of a list		    */
  writelist(ROW,COL,STRINGLIST)		/* used in the menu predicates	    */
  write_center(INTEGER,INTEGER,STRINGLIST)
  reverseattr(ATTR,ATTR)		/* Returns the reversed attribute   */
  min(ROW,ROW,ROW) min(COL,COL,COL) min(LEN,LEN,LEN) min(INTEGER,INTEGER,INTEGER)
'51  max(ROW,ROW,ROW) max(COL,COL,COL) max(LEN,LEN,LEN) max(INTEGER,INTEGER,INTEGER)
  upc(CHAR,CHAR)  lowc(CHAR,CHAR)
  try_upper(CHAR,STRING)
  tryfirstupper(CHAR,STRINGLIST,ROW,ROW)
  tryfirstletter(CHAR,STRINGLIST,ROW,ROW)
  tryletter(CHAR,STRINGLIST,ROW)
  adjustwindow(ROW,COL,ROW,COL,ROW,COL)
  adjframe(ATTR,ROW,COL,ROW,COL)
  make_adj_window(INTEGER,ATTR,ATTR,STRING,ROW,COL)
  readkey(KEY)

  makelist(STRINGLIST)
  edit_list(STRINGLIST,STRINGLIST)
  list_string(STRINGLIST,STRING)
  string_list(STRING,STRINGLIST)
  search_ch(CHAR,STRING,INTEGER,INTEGER)
  member(INTEGER,INTEGERLIST)
  append(STRINGLIST,STRINGLIST,STRINGLIST)
  unik_list(STRINGLIST,STRINGLIST)
  define_number(STRINGLIST,STRING,INTEGER)
  define_member(STRINGLIST,INTEGER,STRING)
  convert_list_string(INTEGERLIST,STRING)
  convert_string_list(STRING,INTEGERLIST)
  convert_stringlist_string(STRINGLIST,STRING)
  make_number_list(STRINGLIST,STRINGLIST,INTEGERLIST)
  
*/
	readkey1(KEY,CHAR,INTEGER)
	readkey2(KEY,INTEGER)
	sort1(INTEGERLIST,INTEGERLIST,INTEGERLIST)
	split(INTEGERLIST,INTEGER,INTEGERLIST,INTEGERLIST)
	sort1_str(STRINGLIST,STRINGLIST,STRINGLIST)
	split_str(STRINGLIST,STRING,STRINGLIST,STRINGLIST)
	paste_name(INTEGER,STRING,STRING,STRING,STRING)
	get_titles(STRINGLIST,STRINGLIST)
CLAUSES
attention(MSG,QUERY):-
		makewindow(1,56,14,attention_msg,8,25,10,30),
		str_len(QUERY,LEN),COL=13-LEN div 2,max(0,COL,START),
		min(LEN,28,SHOWLEN),
		field_str(4,START,SHOWLEN,QUERY),
		makewindow(2,56,0,"",9,26,4,28),
		window_str(MSG),
		fail;
		QUERY=stand_bye,!;
		QUERY<>"",
		boxmenu(99,15,33,1,15,56,0,["O'KEY","CANCEL"],"",1,CHOICE),
		removewindow(2,1),
		removewindow(1,1),!,
		CHOICE=1;
		read_complex_key(_),
		removewindow(2,1),
		removewindow(1,1).

  for(X,X,_).
  for(I,A,B):-B>A,A1=A+1,for(I,A1,B).

  repeat.
  repeat:-repeat.

delay(SECONDS):-time(_,_,S1,_),
		repeat,
		time(_,_,T,_),
		abs(T-S1)>SECONDS,!.

/****************************************************************/
/*		miscellaneous					*/
/****************************************************************/
  maxvalue([],0):-!.
  maxvalue([MAX],MAX):-!.
  maxvalue([H|T],MAX):-maxvalue(T,MAX_TEMP),max(H,MAX_TEMP,MAX).

  maxlen([H|T],MAX,MAX1) :-
	str_len(H,LENGTH),
	LENGTH>MAX,!,
	maxlen(T,LENGTH,MAX1).
  maxlen([_|T],MAX,MAX1) :- maxlen(T,MAX,MAX1).
  maxlen([],LENGTH,LENGTH).

  listlen([],0).
  listlen([_|T],N):-
	listlen(T,X),
	N=X+1.
  
  integer_listlen([],0).
  integer_listlen([_|T],N):-
	integer_listlen(T,X),
	N=X+1.

  writelist(_,_,[]).
  writelist(LI,ANTKOL,[H|T]):-
	field_str(LI,0,ANTKOL,H),
	LI1=LI+1,
	writelist(LI1,ANTKOL,T).

  write_center(_,_,[]):-!.
  write_center(ROW,SIZE,[H|TAIL]):-str_len(H,LEN),COL=(SIZE-LEN+1) div 2,
		field_str(ROW,COL,LEN,H),
		R1=ROW+1,
		write_center(R1,SIZE,TAIL).

  
  min(X,Y,X):-X<=Y,!.
  min(_,X,X).

  max(X,Y,X):-X>=Y,!.
  max(_,X,X).
  
  intense(ATTR,ATTR1):-
	bitxor(ATTR,$08,ATTR1).
  
  reverseattr(A1,A2):-
	bitand(A1,$07,H11),
	bitleft(H11,4,H12),
	bitand(A1,$70,H21),
	bitright(H21,4,H22),
	bitand(A1,$08,H31),
	A2=H12+H22+H31.


/****************************************************************/
/*	Find letter selection in a list of strings		*/
/*      Look initially for first uppercase letter.		*/
/*      Then try with first letter of each string.		*/
/****************************************************************/

  upc(CHAR,CH):-
	CHAR>='a',CHAR<='z',!,
	char_int(CHAR,CI), CI1=CI-32, char_int(CH,CI1).
  upc(CH,CH).

  lowc(CHAR,CH):-
	CHAR>='A',CHAR<='Z',!,
	char_int(CHAR,CI), CI1=CI+32, char_int(CH,CI1).
  lowc(CH,CH).

  try_upper(CHAR,STRING):-
	frontchar(STRING,CH,_),
	CH>='A',CH<='Z',!,
	CH=CHAR.
  try_upper(CHAR,STRING):-
	frontchar(STRING,_,REST),
	try_upper(CHAR,REST).

  tryfirstupper(CHAR,[W|_],N,N) :-
	try_upper(CHAR,W),!.
  tryfirstupper(CHAR,[_|T],N1,N2) :-
	N3 = N1+1,
	tryfirstupper(CHAR,T,N3,N2).

  tryfirstletter(CHAR,[W|_],N,N) :-
	frontchar(W,CHAR,_),!.
  tryfirstletter(CHAR,[_|T],N1,N2) :-
	N3 = N1+1,
	tryfirstletter(CHAR,T,N3,N2).

  tryletter(CHAR,LIST,SELECTION):-
	upc(CHAR,CH),tryfirstupper(CH,LIST,0,SELECTION),!.
  tryletter(CHAR,LIST,SELECTION):-
	lowc(CHAR,CH),tryfirstletter(CH,LIST,0,SELECTION).



/*****************************************************************/
/* adjustwindow takes a windowstart and a windowsize and adjusts */
/* the windowstart so the window can be placed on the screen.	 */
/* adjframe looks at the frameattribute: if it is different from */
/* zero, two is added to the size of the window			 */
/****************************************************************/

  adjustwindow(LI,KOL,DLI,DKOL,ALI,AKOL):-
		LI<25-DLI,KOL<80-DKOL,!,ALI=LI,AKOL=KOL.
  adjustwindow(LI,_,DLI,DKOL,ALI,AKOL):-
		LI<25-DLI,!,ALI=LI,AKOL=80-DKOL.
  adjustwindow(_,KOL,DLI,DKOL,ALI,AKOL):-
		KOL<80-DKOL,!,ALI=25-DLI, AKOL=KOL.
  adjustwindow(_,_,DLI,DKOL,ALI,AKOL):-
		ALI=25-DLI, AKOL=80-DKOL.

  adjframe(0,R,C,R,C):-!.
  adjframe(_,R1,C1,HH1,HH2):-R2=R1+2,C2=C1+2,min(R2,23,HH1),min(C2,78,HH2).

make_adj_window(NUMB,WATTR,FATTR,HEADER,NOOFROW,NOOFCOL):-
	makewindow(_,_,_,_,R,C,_,_),cursor(RC,CC),RW=R+RC,CW=C+CC,
	adjframe(7,NOOFROW,NOOFCOL,HH1,HH2),
	adjustwindow(RW,CW,HH1,HH2,AROW,ACOL),
	makewindow(NUMB,WATTR,FATTR,HEADER,AROW,ACOL,HH1,HH2,1,255,"Ĳ").
	

/****************************************************************/
/* 			Readkey					*/
/* Returns a symbolic key from the KEY domain		        */
/****************************************************************/


  readkey(KEY):-readchar(T),char_int(T,VAL),readkey1(KEY,T,VAL).

  readkey1(KEY,_,0):-!,readchar(T),char_int(T,VAL),readkey2(KEY,VAL).
  readkey1(cr,_,13):-!.
  readkey1(esc,_,27):-!.
  readkey1(break,_,3):-!.
  readkey1(tab,_,9):-!.
  readkey1(bdel,_,8):-!.
  readkey1(ctrlbdel,_,127):-!.
  readkey1(char(T),T,_) .
  
  readkey2(btab,15):-!.
  readkey2(del,83):-!.
  readkey2(ins,82):-!.
  readkey2(up,72):-!.
  readkey2(down,80):-!.
  readkey2(left,75):-!.
  readkey2(right,77):-!.
  readkey2(pgup,73):-!.
  readkey2(pgdn,81):-!.
  readkey2(end,79):-!.
  readkey2(home,71):-!.
  readkey2(ctrlleft,115):-!.
  readkey2(ctrlright,116):-!.
  readkey2(ctrlend,117):-!.
  readkey2(ctrlpgdn,118):-!.
  readkey2(ctrlhome,119):-!.
  readkey2(ctrlpgup,132):-!.
  readkey2(fkey(N),VAL):- VAL>58, VAL<70, N=VAL-58, !.
  readkey2(fkey(N),VAL):- VAL>=84, VAL<104, N=11+VAL-84, !.
/*
  readkey2(otherspec,45):-line_choice(11),!.		% alt+X pressed, exit.
  readkey2(otherspec,22):-			% alt+U pressed
  		not(designer),
  		not(menuchoice("",up_status)),	% Not Alt+L
  		not(menuchoice("",screen_window)),% Not Alt+E
  		not(menuchoice("",22)),		% Not Alt+U active
  		tools,!,fail.			% Up menu
  readkey2(otherspec,38):-			% alt+L pressed
  		not(designer),
  		not(menuchoice("",22)),		% Not Alt+U active
  		not(menuchoice("",up_status)),	% branch(14) should setup
  						% and reset that menuchoice 
  		execute_branch(14),!,fail.	% Lookup
  readkey2(otherspec,38):-			% alt+L pressed
  		not(designer),
  		menuchoice("",up_status),	% Lookup active
  		attention(lookup_already,""),!.
  readkey2(otherspec,18):-			% alt+E pressed
  		not(designer),
  		not(menuchoice("",up_status)),	% Not Alt+L
  		not(menuchoice("",22)),		% Not Alt+U active
  		not(menuchoice("",screen_window)),% branch(2) should setup
  						% and reset that menuchoice 
  		execute_branch(2),!,fail.	% Edit record
  readkey2(otherspec,18):-			% alt+E pressed
  		not(designer),
  		menuchoice("",screen_window),	% Edit active
  		attention(edit_already,""),!.
*/
  readkey2(otherspec,_).


/******************* 	LIST 	PREDICATES 		******/

makelist(STRINGLIST):-
	edit("",STRING),
	string_list(STRING,STRINGLIST).

edit_list(IN,SORTED):-
	list_string(IN,STR_IN),
	edit_text(STR_IN,1,STR_OUT),
	string_list(STR_OUT,OUT),
	sort_alt(OUT,SORTED).

list_string([],"").
list_string([H|TAIL],STR):-list_string(TAIL,TEMP),
	format(STR,"%\n%",H,TEMP).
	
string_list("",[]):-!.
string_list(STR,[H|TAIL]):-
	searchchar(STR,'\n',END_OF_LINE),
%	search_ch('\n',STR,1,END_OF_LINE),
	LEN=END_OF_LINE-1,
	frontstr(LEN,STR,H,TEMP1),frontchar(TEMP1,_,TEMP),
	string_list(TEMP,TAIL),!.
string_list(S,[S]).

/** nondeterm member **/
member(H,[H|_]):-!.
member(H,[_|TAIL]):-member(H,TAIL).

append([],LIST,LIST):-!.
append([H|TAIL],LIST,[H|TEMP]):-append(TAIL,LIST,TEMP).

unik_list([H],[H]):-!.
unik_list([H|[S|TAIL]],[H|TEMP]):-H<>S,unik_list([S|TAIL],TEMP),!.
unik_list([_|TAIL],OUT):-unik_list(TAIL,OUT).

replace([],_,_,[]):-!.
replace([OLD|T],OLD,NEW,[NEW|T]):-!.
replace([H|T],OLD,NEW,[H|REPLACED]):-replace(T,OLD,NEW,REPLACED).

/*	sort		*/

    sort(INTEGERLIST,RESULT):-
          sort1(INTEGERLIST,[],RESULT).    
    sort1([HEAD|TAIL],SORTEDBIGGER,RESULT):-
          split(TAIL,HEAD,LESSLIST,BIGGERLIST),
          sort1(BIGGERLIST,SORTEDBIGGER,NEWSORTEDBIGGER),
          sort1(LESSLIST,[HEAD|NEWSORTEDBIGGER],RESULT).
    sort1([],SORTED,SORTED).

    split([],_,[],[]).
    split([Y|L],X,[Y|L1],L2):-Y<X,!,split(L,X,L1,L2).
    split([Y|L],X,L1,[Y|L2]):-split(L,X,L1,L2).
    
    sort_str(STRINGLIST,RESULT):-
          sort1_str(STRINGLIST,[],RESULT).    
    sort1_str([HEAD|TAIL],SORTEDBIGGER,RESULT):-
          split_str(TAIL,HEAD,LESSLIST,BIGGERLIST),
          sort1_str(BIGGERLIST,SORTEDBIGGER,NEWSORTEDBIGGER),
          sort1_str(LESSLIST,[HEAD|NEWSORTEDBIGGER],RESULT).
    sort1_str([],SORTED,SORTED).

    split_str([],_,[],[]).
    split_str([Y|L],X,[Y|L1],L2):-Y<X,!,split_str(L,X,L1,L2).
    split_str([Y|L],X,L1,[Y|L2]):-split_str(L,X,L1,L2).

/*	define number in list		*/
define_number([],_,1):-!.	% value not found ,default = 1
define_number([H|_],H,1):-!.	% value found
define_number([_|T],V,N):-define_number(T,V,TEMP),
	N=TEMP+1.
/*	convert string "1 2 3 4" into integer list [1,2,3,4]	*/
convert_string_list("",[]):-!.
convert_string_list(STR,[H|TEMP]):-
	fronttoken(STR,TOKEN,TAIL),!,
	str_int(TOKEN,H),
	convert_string_list(TAIL,TEMP).
convert_string_list(_,[]):-!.
/*	convert list [1,2,3,4] into string "1 2 3 4"	*/
convert_list_string([H],STR):-str_int(STR,H),!.
convert_list_string([H|TAIL],STR):-
	convert_list_string(TAIL,TEMP),
	format(STR,"% %",H,TEMP).
/*	convert ["aaa","bbb","ccc"] to "{aaa}\n{bbb}\n{ccc}\n"*/
convert_stringlist_string([H],STR):-format(STR,"{%s}\n",H),!.
convert_stringlist_string([H|TAIL],STR):-
	convert_stringlist_string(TAIL,TEMP),
	format(STR,"{%s}\n%s",H,TEMP).
/*								*/
define_member(_,0,""):-!.
define_member([H|_],1,H):-!.
define_member([_|T],N,MEMB):-N1=N-1,define_member(T,N1,MEMB).

/*	REFERENCE LIST PROCESSING				*/
%define_ref_number([],_,I,I):-!.
define_ref_number([],_,_,_):-!,fail.	% ᫨  뫪  ᯨ᪥
define_ref_number([REF|_],REF,NUM,NUM):-!.
define_ref_number([_|TAIL],REF,I,NUM):-I1=I+1,
		define_ref_number(TAIL,REF,I1,NUM).

define_number_ref([],_,_):-!,fail.
define_number_ref([REF|_],1,REF):-!.
define_number_ref([_|TAIL],I,REF):-I1=I-1,define_number_ref(TAIL,I1,REF).

/*		EXTRACT SUBLIST FROM LIST			*/
%extract_list(1,CHOICELIST,MENULIST,FNAMELIST),
extract_list(_,[],_,[]):-!.
extract_list(_,_,[],[]):-!.
extract_list(NUM,[NUM|NT],[H|T],[H|REST]):-
	NEW=NUM+1,!,
	extract_list(NEW,NT,T,REST).
extract_list(NUM,NUMLIST,[_|TAIL],SUBLIST):-
	NEW=NUM+1,!,
	extract_list(NEW,NUMLIST,TAIL,SUBLIST).

make_number_list([],_,[]):-!.
make_number_list([H|T],FNAMELIST,[NUMBER|NT]):-
	define_number(FNAMELIST,H,NUMBER),
	make_number_list(T,FNAMELIST,NT).

get_key(Dbase,Btree,KEY,REF):-
	key_current(Dbase,Btree,KEY,REF).
get_key(Dbase,Btree,KEY,REF):-
	key_next(Dbase,Btree,_),
%	trap(ref_term(Dbase,stringlist,NextRef,_),Err,error_pred(Err,"")),
	get_key(Dbase,Btree,KEY,REF).

copy_keys(Dbase,Btree,NewBtree):-
	pas(MODE,PASSW),
	ENCRYPT=-MODE,
	get_key(Dbase,Btree,Key,REF),
	protect(ENCRYPT,PASSW,KEY),
	key_insert(lookup,NewBtree,KEY,REF),
	fail;
	true.	


/************************************************************************/

PREDICATES
select_filename1(STRING,STRING)
select_filename2(STRING,STRING)
check_fname(STRING)
change_case(STRINGLIST,STRINGLIST,symbol)	

CLAUSES
get_file_name(EXT,FNAME):-
	repeat,
	%
  	select_filename1(EXT,FNAME),
  	check_fname(FNAME),!,FNAME<>"".

get_screen(FNAME):-
	repeat,
	%
  	select_filename2(file_selector,FNAME),
  	check_fname(FNAME),!,FNAME<>"".

select_filename1(Wild,FNAME):-
	findall(X,dirfiles(Wild,$EF,X,_,_,_,_,_,_,_,_),FNAMELIST),
	findall(Y,dirfiles("*.*",$10,Y,_,_,_,_,_,_,_,_),DIRLIST),
  	change_case(DIRLIST,UPLIST,up),
  	sort_str(UPLIST,UPSORT),
  	change_case(FNAMELIST,LOWLIST,low),
  	sort_str(LOWLIST,LOWSORT),
  	append(UPSORT,LOWSORT,LIST1),
  	append(drivelist,LIST1,LIST),
	disk(CAT),
	boxmenu(77,5,12,10,39,7,7,LIST,CAT,7,CHOICE),CHOICE<>0,!,
	define_member(LIST,CHOICE,FN),
	frontstr(2,CAT,DISK,DIR),
	paste_name(CHOICE,DISK,DIR,FN,FNAME).
select_filename1(_,"").

select_filename2(Wild,FNAME):-
	findall(X,dirfiles(Wild,$EF,X,_,_,_,_,_,_,_,_),FNAMELIST),
	findall(Y,dirfiles("*.*",$10,Y,_,_,_,_,_,_,_,_),DIRLIST),
  	change_case(DIRLIST,UPLIST,up),
  	sort_str(UPLIST,UPSORT),
  	get_titles(FNAMELIST,TITLELIST),		% append to filename
  	sort_str(TITLELIST,LOWSORT),			% title
  	append(UPSORT,LOWSORT,LIST1),
  	append(drivelist,LIST1,LIST),
	disk(CAT),
	longmenu(change_alt,7,10,10,3,7,LIST,"Choose database",1,CHOICE,FN),!,
	frontstr(2,CAT,DISK,DIR),
	paste_name(CHOICE,DISK,DIR,FN,FNAME).
select_filename2(_,"").
%  	attention("Selected:",FNAME),

paste_name(CHOICE,_,_,_,_):- % setup new drive
	CHOICE<=6,
	DRIVE_NO=CHOICE-1,
	AX=$0e*256,
	bios($21,reg(AX,0,0,DRIVE_NO,0,0,0,0),reg(_,_,_,_,_,_,_,_)),!,fail.
paste_name(_,DISK,"\\",FN,FNAME):-concat(DISK,FN,FNAME),!.
paste_name(_,DISK,DIR,FN,FNAME):-
	searchstring(FN,".{p}",FoundPos),!,	% database filename
	Length=FoundPos+4,
	frontstr(Length,FN,FN1,_),
	fronttoken(FN1,T1,T2),
	format(FNAME,"%s%s\\%s%s",DISK,DIR,T1,T2).
paste_name(_,_,_,FN,FN).
	
get_titles([],[]):-!.
get_titles([H|T],[TITLE|TAIL]):-
	trap(db_openinvalid(dba_out,H,in_file),_,error_pred(-1,"")),
	chain_first(dba_out,title,FirstRef),
	ref_term(dba_out,string,FirstRef,HEADER),
	upper_lower(H,HLOW),
	format(TITLE,"%11s :%",HLOW,HEADER),
	db_close(dba_out),!,
	get_titles(T,TAIL).
get_titles([H|T],[TITLE|TAIL]):-
	upper_lower(H,HLOW),
	db_close(dba_out),
	format(TITLE,"%11s :",HLOW),
	get_titles(T,TAIL).

check_fname(FNAME):-existfile(FNAME),!.
check_fname(""):-!.
check_fname(".."):-disk(".."),!,fail.
check_fname(DIRNAME):-disk(DIRNAME),!,fail.

change_case([],[],_):-!.
change_case(["."|T],NEW,CASE):-change_case(T,NEW,CASE),!.
change_case([H|T],[UP|NEW],up):-upper_lower(UP,H),change_case(T,NEW,up),!.
change_case([H|T],[LOW|NEW],low):-upper_lower(H,LOW),change_case(T,NEW,low),!.

 /***********************************************************************
                                                                      
     Turbo Prolog Toolbox
     (C) Copyright 1987 Borland International.                        
                                                                      
 ***********************************************************************/

  makestatus(ATTR,TXT):-
  	shiftwindow(OLD),
%  	windowsize(R,_),R1=R+4,
  	textmode(MAXROW1,COL),MAXROW=MAXROW1-1,
%  	min(MAXROW,R1,STATROW),
  	makewindow(help_window,ATTR,0,"",MAXROW,0,1,COL),
  	window_str(TXT),
	shiftwindow(OLD),!.
  makestatus(ATTR,TXT):-assert(windowsize(20,62)),
  	makestatus(ATTR,TXT).

  tempstatus(ATTR,TXT):-makestatus(ATTR,TXT).
  tempstatus(_,_):-removestatus,fail.

  removestatus:-existwindow(help_window),!,
	shiftwindow(OLD),
	shiftwindow(help_window), removewindow,
	shiftwindow(OLD);
	true.

  refreshstatus.

  changestatus(TXT):-
	shiftwindow(OLD),
	shiftwindow(help_window),
	field_str(0,0,80,TXT),
	shiftwindow(OLD).

/****************************************************************
	File extention
****************************************************************/
PREDICATES
%  newext(STRING,STRING,STRING)
%  extentfilename(STRING,STRING,STRING)
  splitfilename(STRING,STRING,STRING)
  search_char(CHAR,STRING,INTEGER,INTEGER)
  concatlist(STRINGLIST,STRING)

CLAUSES
/* replace old extension with the new extension */
  newext(OLD,EXT,NEW):-
	splitfilename(OLD,NAME,_),
	concatlist([NAME,".",EXT],NEW).

  extentfilename(OLDNAME,EXT,FILENAME):-
	splitfilename(OLDNAME,NAME,OLDEXT), OLDEXT="",!,
	concatlist([NAME,".",EXT],FILENAME).
  extentfilename(NAME,_,NAME).

/* parse file name string for name and extension */
  splitfilename(FILENAME,NAME,EXT):-
	search_char('.',FILENAME,0,N),
	frontstr(N,FILENAME,NAME,REST),
	frontchar(REST,_,EXT),!.
  splitfilename(NAME,NAME,"").

  search_char(CH,STR,N,N) :-frontchar(STR,CH,_),!.
  search_char(CH,STR,N,N2) :-
         frontchar(STR,_,STR1),
         N1=N+1,
         search_char(CH,STR1,N1,N2).

  concatlist([],"").
  concatlist([H|T],S):-
	concatlist(T,S1),
	concat(H,S1,S).

/****************************************************************
	Matching fields
****************************************************************/

PREDICATES
% match_substring(INTEGER,INTEGER,STRING,STRING).

CLAUSES
  match_substring(LEN1,LEN2,V1,V2):-
  	LEN1>=LEN2,
  	searchstring(V1,V2,_),!.
  match_substring(_,_,V1,V2):-
  	searchstring(V2,V1,_),!.

adjust_file(FILE,ADJUST):-
		syspath(CAT,_),
%		syscat(CAT),
		filenamepath(ADJUST,CAT,FILE),!.

enter(HEADER,OLD,NEW):-
	makewindow(13,48,14,enter_header,10,10,6,45,1,5,"ڿĳ"),
	str_len(HEADER,LEN),START=(45-LEN) div 2,max(0,START,S1),
	field_str(3,S1,LEN,HEADER),
	lineinput(line_print_6,12,15,35,7,0,"",OLD,NEW),!,
	removewindow(13,1);
	removewindow(13,1),fail.

check_btree(DB_SELECTOR,BTREE_NAME):-
		db_btrees(DB_SELECTOR,BTREE),
		BTREE=BTREE_NAME,!.

del_btree(DB_SELECTOR,BTREE_NAME):-
		check_btree(DB_SELECTOR,BTREE_NAME),
		format(HEADER,"del_btree: %",BTREE_NAME),
		trap(bt_delete(DB_SELECTOR,BTREE_NAME),
			Err,error_pred(Err,HEADER)),!;
		true.

%predicates
%	set_cursor_form(KEY)

clauses
set_cursor_form(esc):-!.
set_cursor_form(down):-
	cursorform(START,END),
	START<13,!,
	NEWSTART=START+1,
	cursorform(NEWSTART,END).
set_cursor_form(up):-
	cursorform(START,END),
	START>2,!,
	NEWSTART=START-1,
	cursorform(NEWSTART,END).
set_cursor_form(right):-
	cursorform(START,END),
	END<13,!,
	NEWEND=END+1,
	cursorform(START,NEWEND).
set_cursor_form(left):-
	cursorform(START,END),
	END>2,!,
	NEWEND=END-1,
	cursorform(START,NEWEND).
