project "complex"
%shorttrace define_area, init_mouse_driver
/*  PULLDOWN like 3DS	*/
code=4500
constants
tree_right = true
tree_down = false

include "..\\include\\constant.pro"
include "..\\include\\tdoms.pro"
include "..\\include\\dbase.pro"
include "..\\include\\sorted.pro"
include "..\\include\\service.pro"
include "..\\include\\ex_line.pro"
include "..\\include\\mousekey.pro"
include "..\\include\\mouse.pro"
include "..\\include\\ex_long2.pro"
%include "..\\include\\ex_boxmn.pro"
include "..\\include\\tree.pro"
%include "..\\include\\gardener.pro"

include "pulldn3d.pro"
include "sen_an.pro"

PREDICATES
	main_loop
	init_screen
	define_area(INTEGER,INTEGER,INTEGER)
	execute_key(KEY,INTEGER)
	accept_choice(INTEGER,INTEGER,PULL_LIST)

CLAUSES

main_loop:-
	assert(choice(0,
	[pull("Exit",a,-1,[]),
	 pull("Load",a,1000,[		% open level Load
		 pull(" Text",p,1001,[]),
		 pull(" Database",a,1002,[]),
		 pull(" Clear base",p,1003,[])
				]),		% close level Load
	 pull("Save",p,2000,[		% open level Load
		 pull(" Text",p,2001,[]),
		 pull(" Database",a,2002,[]),
		 pull(" Tree",p,2003,[])
				]),		% close level Load
	 pull("Edit",p,3000,[		% open level Load
		 pull(" Text",p,3001,[]),
		 pull(" Database",a,3002,[])
				]),		% close level Load
	 pull("Show",p,4000,[		% open level Show
		 pull(" Verbs",p,4001,[]),
		 pull(" Nouns",p,4002,[]),
		 pull(" Relatives",p,4003,[]),
		 pull(" Determs",p,4004,[]),
		 pull(" Tree",a,4005,[]),
		 pull(" Errors",p,4006,[])
				]),		% close level Show
	 pull("Add",p,5000,[		% open level Add
		 pull(" Verbs",a,5001,[]),
		 pull(" Nouns",p,5002,[]),
		 pull(" Relatives",p,5003,[]),
		 pull(" Determs",p,5004,[])
				]),		% close level Add
	 pull("Analyze",p,6000,[		% open level Analyse
		 pull(" Senetnce",p,6001,[]),
		 pull(" Text",a,6002,[])
				]),		% close level Analyse
	 pull("Help",p,8000,[		% open level Analyse
		 pull(" Analyser",a,8001,[]),
		 pull(" TreeBrowse",p,8002,[])
				]),		% close level Analyse
	 pull("Print",a,7000,[		% open level Print
		 pull(" 4.5 act",a,7100,[	% open level Format
			pull("   4.5.1",p,7110,[]),
			pull("   4.5.2 act",a,7120,[]),
			pull("   4.5.3",p,7130,[
			  pull("    4.8.1 act",a,7131,[	% open level Format
				pull("     4.8.1",p,7132,[]),
				pull("     4.8.2",a,7133,[])
								 ])  % Close level Format
								  ])
							  ]),
		 pull(" 4.12",p,7101,[])
				])]		% close level Print
			)),
	repeat,
	read_complex_key(KEY),
	read_mouse(_,Ymouse,Xmouse),
	define_area(Xmouse,Ymouse,AREA),
	execute_key(KEY,AREA),!.

execute_key(esc,_):-
	execute_branch(-1),!.
execute_key(_,menu_window):-
	retract(choice(START,PULL_LIST)),
	pull_down_menu(menu_window,START,PULL_LIST,SELECTOR,CHOICE,UPDATED_MENU),
	shiftwindow(screen_window),
	execute_branch(SELECTOR),
	accept_choice(CHOICE,START,UPDATED_MENU),
	CHOICE=0,!,fail.
execute_key(_,screen_window):-
	shiftwindow(screen_window),
	read_complex_key(_),!,fail.
execute_key(_,top_line):-
	shiftwindow(top_line),
	read_complex_key(_),!,fail.
execute_key(_,help_window):-
	shiftwindow(help_window),
	read_complex_key(_),!,fail.

accept_choice(_,_,_):-retract(choice(_,_)),fail.
accept_choice(0,OLD,MENU):-assert(choice(OLD,MENU)),!.
accept_choice(CHOICE,_,MENU):-assert(choice(CHOICE,MENU)),!.

init_screen:-
	textmode(MAXROW,_),
	H=MAXROW-1,H2=MAXROW-2,
	makewindow(top_line,19,0,"",0,0,1,65),
%	field_attr(0,0,10,116),field_str(0,0,10,"Exit"),
	field_attr(0,64,1,17),
	makewindow(menu_window,19,0,"",0,65,H,15),
	makewindow(screen_window,48,16,"Screen",1,0,H2,65),
	makewindow(help_window,30,0,"",H,0,1,80).

define_area(X,0,top_line):-X<=64,X>10,!.
define_area(X,0,exit_line):-X<=10,!.
define_area(_,ROW,help_window):-textmode(MAXROW,_),ROW=MAXROW-1,!.
define_area(X,Y,menu_window):-textmode(MAXROW,_),X>64,Y<=MAXROW-2,!.
define_area(_,_,screen_window).


GOAL	trace(on),
	init_screen,
	init_mouse_driver,
	openappend(out,"right.sen"),
	openappend(err,"error.sen"),
	openwrite(tree_out,"sen_tree.cnf"),
	execute_branch(1002),
	main_loop.
	
