
/* PULLDOWN menu like 3D Studio	*/

PREDICATES
  define_integer_number(INTEGERLIST,INTEGER,INTEGER)
  append_integer(INTEGERLIST,INTEGERLIST,INTEGERLIST)
CLAUSES
/*	define number in integerlist		*/
define_integer_number(_,0,-1):-!,fail.
define_integer_number([H|_],1,H):-!.	% value found
define_integer_number([_|T],N,VALUE):-
	TEMP=N-1,
	define_integer_number(T,TEMP,VALUE).

append_integer([],LIST,LIST):-!.
append_integer([H|TAIL],LIST,[H|TEMP]):-append_integer(TAIL,LIST,TEMP).

PREDICATES
%	check_start
%	pull_down_menu(INTEGER,INTEGER,PULL_LIST,INTEGER,INTEGER,PULL_LIST)
	scan_pull(PULL_LIST,INTEGER,STRINGLIST,INTEGERLIST,INTEGERLIST)
	names_of_level(PULL_LIST,STRINGLIST,INTEGERLIST)
	selector_in_level(PULL_LIST,SELECTOR)
	update_level(PULL_LIST,SELECTOR,PULL_LIST)
	next_level(PULL_LIST,SELECTOR,PULL_LIST)
	update_pull_menu(PULL_LIST,SELECTOR,PULL_LIST)
	get_start(INTEGERLIST,INTEGER)
CLAUSES
selector_in_level([],_):-!,fail.
selector_in_level([pull(_,_,SEL,_)|_],SEL):-!.
selector_in_level([_|TAIL],SEL):-selector_in_level(TAIL,SEL).

update_level([],_,[]):-!.
update_level([pull(NAME,_,SEL,LIST)|TAIL],SEL,
	[pull(NAME,a,SEL,LIST)|NEWTAIL]):-!,
	update_level(TAIL,SEL,NEWTAIL).
update_level([pull(NAME,_,NUM,LIST)|TAIL],SEL,
	[pull(NAME,p,NUM,LIST)|NEWTAIL]):-
	update_level(TAIL,SEL,NEWTAIL).

next_level([pull(NAME,a,NUM,LEVEL)|TAIL],SEL,
	[pull(NAME,a,NUM,UPDATED)|TAIL]):-!,
	update_pull_menu(LEVEL,SEL,UPDATED).
next_level([H|TAIL],SEL,[H|NEWTAIL]):-
	next_level(TAIL,SEL,NEWTAIL).

update_pull_menu(LEVEL,SEL,UPDATED):-
	selector_in_level(LEVEL,SEL),!,
	update_level(LEVEL,SEL,UPDATED).
update_pull_menu(LEVEL,SEL,UPDATED):-
	next_level(LEVEL,SEL,UPDATED).

pull_down_menu(WIND,_,PULL_LIST,SELECTOR,CHOICE,UPDATED_MENU):-
	shiftwindow(WIND),
	scan_pull(PULL_LIST,0,NAMELIST,SELECTORLIST,HIGHLIST),
	get_start(HIGHLIST,START),
	longmenu_old(NAMELIST,START,HIGHLIST,31,30,CHOICE,_),
	define_integer_number(SELECTORLIST,CHOICE,SELECTOR),
	update_pull_menu(PULL_LIST,SELECTOR,UPDATED_MENU),!.
pull_down_menu(_,_,PULL_LIST,-1,0,PULL_LIST).
/*
check_start:-
	designer,
	retract(choice(_,PULL_LIST)),!,
	update_pull_menu(PULL_LIST,700,UPDATED_MENU),
	assert(choice(701,UPDATED_MENU));
	true.
*/
get_start([S],START):-START=S+1,!.
get_start([_|T],S):-get_start(T,S).

names_of_level([],[],[]):-!.
names_of_level([pull(NAME,_,SEL,_)|TAIL],[NAME|NTAIL],[SEL|STAIL]):-
	names_of_level(TAIL,NTAIL,STAIL).

scan_pull([],_,[],[],[]):-!.
scan_pull([pull(NAME,p,SELECTOR,_)|PTAIL],INDEX,
		[NAME|NAMETAIL],[SELECTOR|STAIL],HIGHLIST):-
	NEWINDEX=INDEX+1,
	scan_pull(PTAIL,NEWINDEX,NAMETAIL,STAIL,HIGHLIST),!.
scan_pull([pull(NAME,a,SELECTOR,PULLLIST)|PTAIL],INDEX,
		[NAME|NAMETAIL],[SELECTOR|SELTAIL],[INDEX|HTAIL]):-
	names_of_level(PTAIL,LEVELNAMES,LEVELSELS),
	listlen(LEVELNAMES,LEVELSLENGTH),
	NEWINDEX=INDEX+LEVELSLENGTH+1,
	scan_pull(PULLLIST,NEWINDEX,TAIL,STAIL,HTAIL),
	append(LEVELNAMES,TAIL,NAMETAIL),
	append_integer(LEVELSELS,STAIL,SELTAIL),!.
